# InvoiceItems

InvoiceItems object

## Get invoice item

> An invoice item is an individual order item that is part of an invoice.\
> \
> \*\*Note:\*\* This operation needs \[Authentication]\(../guidelines/authentication.md) and supports the following JSON:API features:\
> \
> \- \[Relationships]\(../guidelines/relationships.md) - \`invoiceItemsModifiers\`, \`revenueCenter\` using \`include\` query parameter.\
> \- \[Sparse fieldsets]\(../guidelines/sparse-fieldsets.md) - supports all fields of \`invoiceItem\` and related resources with \`fields\` query parameter.<br>

```json
{"openapi":"3.1.0","info":{"title":"POS API","version":"1.0.0"},"tags":[{"name":"InvoiceItems","description":"InvoiceItems object"}],"servers":[{"url":"https://api.mews.com/pos","description":"Production"},{"url":"https://api.mews-demo.com/pos","description":"Staging"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"auth-scheme","description":"Bearer HTTP authentication. Allowed headers-- Authorization: Bearer <api_key>"}},"parameters":{"fields_invoice_items":{"in":"query","name":"fields[invoiceItems]","schema":{"type":"array","maxItems":18,"items":{"type":"string","enum":["productName","quantity","comp","void","compVoidReason","compVoidNotes","createdAt","updatedAt","unitPriceInclTax","subtotal","tax","total","discount","discountAmount","product","productVariant","revenueCenter","invoiceItemModifiers"]}},"description":"Fields query parameter to allow the client to customize which fields should be returned.","explode":false,"required":false},"fields_revenue_centers":{"in":"query","name":"fields[revenueCenters]","schema":{"type":"array","maxItems":4,"items":{"type":"string","enum":["name","isActive","createdAt","updatedAt"]}},"description":"Fields query parameter to allow the client to customize which fields should be returned.","explode":false,"required":false},"fields_invoice_item_modifiers":{"in":"query","name":"fields[invoiceItemModifiers]","schema":{"type":"array","maxItems":2,"items":{"type":"string","enum":["name","price"]}},"description":"Fields query parameter to allow the client to customize which fields should be returned.","explode":false,"required":false}},"headers":{"x_rate_limit_limit":{"description":"The number of allowed requests in the current period.","schema":{"type":"integer","format":"int32","minimum":1,"maximum":1000}},"x_rate_limit_remaining":{"description":"The number of remaining requests in the current period.","schema":{"type":"integer","format":"int32","minimum":1,"maximum":1000}},"x_rate_limit_reset":{"description":"The time at which the rate limit resets, in UTC epoch seconds.","schema":{"type":"integer","format":"int64","minimum":1633036800,"maximum":2147483647}},"access_control_allow_origin":{"description":"Specifies which origins are allowed to access the resource.","schema":{"type":"string","minLength":1,"maxLength":1024,"pattern":"^[A-Za-z /*]+$"}},"retry_after":{"description":"The time the client should wait before making a new request.","schema":{"type":"integer","format":"int32","minimum":1,"maximum":3600}}},"schemas":{"invoice_items":{"invoice_item_response":{"type":"object","properties":{"data":{"$ref":"#/components/schemas/invoice_items/invoice_item","description":"The document's \"primary data\"."},"included":{"type":["array","null"],"maxItems":1000,"description":"Details of the invoiceItemModifiers to which the invoiceItem is associated.","items":{"anyOf":[{"$ref":"#/components/schemas/invoice_item_modifiers/invoice_item_modifier"},{"$ref":"#/components/schemas/revenue_centers/revenue_center"}]}}},"required":["data"]},"invoice_item":{"type":"object","properties":{"id":{"type":"string","format":"uuid","title":"Resource identifier","description":"Universally unique ID (UUID) that identifies the related object.","minLength":36,"maxLength":36},"type":{"type":"string","const":"invoiceItems","title":"Resource type name","description":"The [type](https://jsonapi.org/format/#document-resource-object-identification) member is used to describe resource objects that share common attributes and relationships."},"attributes":{"type":"object","description":"An [attributes object](https://jsonapi.org/format/#document-resource-object-attributes) representing some of the resource's data.","properties":{"productName":{"type":"string","description":"The name of the product or item being invoiced.","maxLength":255,"pattern":"^[^<>&]+$"},"unitPriceInclTax":{"type":"string","description":"The price of the product per unit, including applicable taxes.","maxLength":255,"pattern":"^[0-9]+\\.[0-9]{2}$"},"quantity":{"type":"string","maxLength":255,"pattern":"^[0-9]+\\.[0-9]{1,2}$","description":"The number of units of the product being purchased."},"subtotal":{"type":"string","maxLength":255,"pattern":"^[0-9]+\\.[0-9]{2}$","description":"The total price of the product before taxes and discounts are applied."},"tax":{"type":"string","maxLength":255,"pattern":"^[0-9]+\\.[0-9]{2}$","description":"The tax amount applicable to the specific item."},"total":{"type":"string","maxLength":255,"pattern":"^[0-9]+\\.[0-9]{2}$","description":"The total price of the item after taxes and discounts have been applied."},"discount":{"type":["string","null"],"maxLength":255,"pattern":"^[0-9]+\\.[0-9]{2}$","description":"The percentage or amount of discount applied specifically to this item."},"comp":{"type":"boolean","description":"Indicates whether the item was provided for free (comped) or not.","deprecated":true},"void":{"type":"boolean","description":"Indicates whether the item has been voided from the invoice.","deprecated":true},"isComp":{"type":"boolean","description":"Indicates whether the item was provided for free (comped) or not."},"isVoid":{"type":"boolean","description":"Indicates whether the item has been voided from the invoice."},"compVoidReason":{"type":["string","null"],"description":"The reason provided for voiding the item, if applicable.","maxLength":255,"pattern":"^[^<>&]+$"},"compVoidNotes":{"type":["string","null"],"description":"Additional notes regarding the comping or voiding of the item.","maxLength":2048,"pattern":"^[^<>&]+$"},"discountAmount":{"type":["string","null"],"description":"The total monetary value of the discount applied to this specific item.","maxLength":255,"pattern":"^[0-9]+\\.[0-9]{1,2}$"},"subtotalInclDiscount":{"type":"string","description":"The subtotal of the item after applying any discounts.","maxLength":255,"pattern":"^[0-9]+\\.[0-9]{1,2}$"},"taxInclDiscount":{"type":"string","description":"The tax amount applicable to the item after applying any discounts.","maxLength":255,"pattern":"^[0-9]+\\.[0-9]{1,2}$"},"totalInclDiscount":{"type":"string","description":"The tax amount applicable to the item after applying any discounts.","maxLength":255,"pattern":"^[0-9]+\\.[0-9]{1,2}$"},"createdAt":{"type":"string","description":"Created at timestamp in RFC 3339 format.","format":"date-time","maxLength":25},"updatedAt":{"type":"string","description":"Updated at timestamp in RFC 3339 format.","format":"date-time","maxLength":25}},"required":["productName","unitPriceInclTax","quantity","subtotal","tax","total","discount","comp","void","isComp","isVoid","compVoidReason","compVoidNotes","discountAmount","createdAt","updatedAt"]},"relationships":{"type":"object","description":"A [relationships object](https://jsonapi.org/format/#document-resource-object-relationships) describing relationships between the resource and other JSON:API resources.","properties":{"product":{"type":"object","description":"Details of the product associated with the invoiceItem.","properties":{"data":{"type":"object","properties":{"id":{"type":"string","format":"uuid","title":"Resource identifier","description":"Universally unique ID (UUID) that identifies the related object.","minLength":36,"maxLength":36},"type":{"type":"string","description":"The [type](https://jsonapi.org/format/#document-resource-object-identification) member is used to describe resource objects that share common attributes and relationships.","const":"products"}},"required":["id","type"]}},"required":["data"]},"productVariant":{"type":"object","description":"Details of the productVariant associated with the invoiceItem.","properties":{"data":{"type":["object","null"],"properties":{"id":{"type":"string","format":"uuid","title":"Resource identifier","description":"Universally unique ID (UUID) that identifies the related object.","minLength":36,"maxLength":36},"type":{"type":"string","description":"The [type](https://jsonapi.org/format/#document-resource-object-identification) member is used to describe resource objects that share common attributes and relationships.","const":"productVariants"}},"required":["id","type"]}},"required":["data"]},"invoiceItemModifiers":{"type":"object","description":"Details of the items associated with the invoiceItem.","properties":{"data":{"type":"array","maxItems":1000,"items":{"type":"object","properties":{"id":{"type":"string","format":"uuid","title":"Resource identifier","description":"Universally unique ID (UUID) that identifies the related object.","minLength":36,"maxLength":36},"type":{"type":"string","description":"The [type](https://jsonapi.org/format/#document-resource-object-identification) member is used to describe resource objects that share common attributes and relationships.","const":"invoiceItemModifiers"}},"required":["id","type"]}}},"required":["data"]},"revenueCenter":{"type":"object","description":"Details of the revenue center associated with the invoiceItem.","properties":{"data":{"type":["object","null"],"properties":{"id":{"type":"string","format":"uuid","title":"Resource identifier","description":"Universally unique ID (UUID) that identifies the related object.","minLength":36,"maxLength":36},"type":{"type":"string","const":"revenueCenters","description":"The [type](https://jsonapi.org/format/#document-resource-object-identification) member is used to describe resource objects that share common attributes and relationships."}},"required":["id","type"]}}}}}},"required":["id","type","attributes"]}},"invoice_item_modifiers":{"invoice_item_modifier":{"type":"object","properties":{"id":{"type":"string","format":"uuid","title":"Resource identifier","description":"Universally unique ID (UUID) that identifies the related object.","minLength":36,"maxLength":36},"type":{"type":"string","const":"invoiceItemModifiers","title":"Resource type name","description":"The [type](https://jsonapi.org/format/#document-resource-object-identification) member is used to describe resource objects that share common attributes and relationships."},"attributes":{"type":"object","description":"An [attributes object](https://jsonapi.org/format/#document-resource-object-attributes) representing some of the resource's data.","properties":{"name":{"type":"string","description":"Name of the modifier item.","maxLength":255,"pattern":"^[^<>&]+$"},"price":{"type":"string","description":"Price of the modifier item.","maxLength":255,"pattern":"^[0-9]+\\.[0-9]{2}$"}},"required":["name","price"]}},"required":["id","type","attributes"]}},"revenue_centers":{"revenue_center":{"type":"object","properties":{"id":{"type":"string","format":"uuid","title":"Resource identifier","description":"Universally unique ID (UUID) that identifies the related object.","minLength":36,"maxLength":36},"type":{"type":"string","title":"Resource type name","description":"The [type](https://jsonapi.org/format/#document-resource-object-identification) member is used to describe resource objects that share common attributes and relationships.","const":"revenueCenters"},"attributes":{"type":"object","description":"An [attributes object](https://jsonapi.org/format/#document-resource-object-attributes) representing some of the resource's data.","properties":{"name":{"type":"string","maxLength":255,"pattern":"^[^<>&]+$","description":"Name of the revenue center."},"isActive":{"type":"boolean","description":"Indicates whether the revenue center is active."},"createdAt":{"type":"string","description":"Created at timestamp in RFC 3339 format.","maxLength":25,"format":"date-time"},"updatedAt":{"type":"string","description":"Updated at timestamp in RFC 3339 format.","maxLength":25,"format":"date-time"}},"required":["name","isActive","createdAt","updatedAt"]}},"required":["id","type","attributes"]}},"error":{"type":"object","description":"A JSON:API error object.\n\nAdditional properties specific to the problem type may be present.    \n","properties":{"errors":{"type":"array","description":"An array of error details to accompany a problem details response.","maxItems":1000,"items":{"type":"object","description":"An object to provide explicit details on a problem towards an API consumer.","properties":{"id":{"type":"string","maxLength":16,"description":"A unique identifier for this particular occurrence of the problem.","pattern":"^[A-Za-z0-9_-]+$"},"status":{"type":"string","maxLength":3,"description":"The HTTP status code applicable to this problem, expressed as a string value.","pattern":"^[1-5][0-9]{2}$"},"code":{"type":"string","maxLength":50,"description":"An application-specific error code, expressed as a string value.","pattern":"^[A-Za-z0-9_-]+$"},"title":{"type":"string","description":"A short, human-readable summary of the problem that SHOULD NOT change from occurrence to occurrence of the problem, except for purposes of localization.","maxLength":256,"pattern":"^.{1,255}$"},"detail":{"type":"string","description":"A human-readable explanation specific to this occurrence of the problem. Like title, this field's value can be localized.","maxLength":1024,"pattern":"^.{1,1023}$"},"source":{"type":"object","properties":{"pointer":{"type":"string","description":"A JSON Pointer to a specific request body property that is the source of error.","maxLength":1024,"pattern":"^$|^/([A-Za-z0-9_-]+/)*[A-Za-z0-9_-]+$"},"parameter":{"type":"string","description":"A string indicating which URI query parameter caused the error.","maxLength":1024,"pattern":"^[A-Za-z0-9_]+$"},"header":{"type":"string","description":"The name of the header that is the source of error.","maxLength":1024,"pattern":"^[A-Za-z-]+$"}}},"meta":{"type":"object","description":"Additional information about the error.","additionalProperties":true}},"required":["title"]}}},"required":["errors"]}},"responses":{"bad_request":{"description":"Bad request.","headers":{"X-Rate-Limit-Limit":{"$ref":"#/components/headers/x_rate_limit_limit"},"X-Rate-Limit-Remaining":{"$ref":"#/components/headers/x_rate_limit_remaining"},"X-Rate-Limit-Reset":{"$ref":"#/components/headers/x_rate_limit_reset"},"Access-Control-Allow-Origin":{"$ref":"#/components/headers/access_control_allow_origin"}},"content":{"application/vnd.api+json":{"schema":{"type":"object","$ref":"#/components/schemas/error"}}}},"unauthorized":{"description":"Unauthorized.","headers":{"X-Rate-Limit-Limit":{"$ref":"#/components/headers/x_rate_limit_limit"},"X-Rate-Limit-Remaining":{"$ref":"#/components/headers/x_rate_limit_remaining"},"X-Rate-Limit-Reset":{"$ref":"#/components/headers/x_rate_limit_reset"},"Access-Control-Allow-Origin":{"$ref":"#/components/headers/access_control_allow_origin"}},"content":{"application/vnd.api+json":{"schema":{"type":"object","$ref":"#/components/schemas/error"}}}},"too_many_requests":{"description":"Too many requests.","headers":{"X-Rate-Limit-Limit":{"$ref":"#/components/headers/x_rate_limit_limit"},"X-Rate-Limit-Remaining":{"$ref":"#/components/headers/x_rate_limit_remaining"},"X-Rate-Limit-Reset":{"$ref":"#/components/headers/x_rate_limit_reset"},"Retry-After":{"$ref":"#/components/headers/retry_after"},"Access-Control-Allow-Origin":{"$ref":"#/components/headers/access_control_allow_origin"}},"content":{"application/vnd.api+json":{"schema":{"type":"object","$ref":"#/components/schemas/error"}}}},"internal_server_error":{"description":"Internal Server Error.","content":{"application/vnd.api+json":{"schema":{"type":"object","$ref":"#/components/schemas/error"}}}},"service_unavailable":{"description":"Service is unavailable.","headers":{"X-Rate-Limit-Limit":{"$ref":"#/components/headers/x_rate_limit_limit"},"X-Rate-Limit-Remaining":{"$ref":"#/components/headers/x_rate_limit_remaining"},"X-Rate-Limit-Reset":{"$ref":"#/components/headers/x_rate_limit_reset"},"Access-Control-Allow-Origin":{"$ref":"#/components/headers/access_control_allow_origin"}},"content":{"application/vnd.api+json":{"schema":{"type":"object","$ref":"#/components/schemas/error"}}}}}},"paths":{"/v1/invoice-items/{id}":{"get":{"operationId":"getInvoiceItem","summary":"Get invoice item","description":"An invoice item is an individual order item that is part of an invoice.\n\n**Note:** This operation needs [Authentication](../guidelines/authentication.md) and supports the following JSON:API features:\n\n- [Relationships](../guidelines/relationships.md) - `invoiceItemsModifiers`, `revenueCenter` using `include` query parameter.\n- [Sparse fieldsets](../guidelines/sparse-fieldsets.md) - supports all fields of `invoiceItem` and related resources with `fields` query parameter.\n","parameters":[{"$ref":"#/components/parameters/fields_invoice_items"},{"$ref":"#/components/parameters/fields_revenue_centers"},{"$ref":"#/components/parameters/fields_invoice_item_modifiers"},{"in":"path","name":"id","description":"The id of the resource.","required":true,"schema":{"type":"string","format":"uuid","title":"Resource identifier","description":"Universally unique ID UUID4.","minLength":36,"maxLength":36}},{"in":"query","name":"include","schema":{"type":"array","maxItems":2,"items":{"type":"string","enum":["invoiceItemModifiers","revenueCenter"]}},"description":"include query parameter to allow the client to customize which related resource should be returned.","required":false}],"tags":["InvoiceItems"],"responses":{"200":{"description":"Successful response with invoiceItems data in JSON:API format.","headers":{"X-Rate-Limit-Limit":{"$ref":"#/components/headers/x_rate_limit_limit"},"X-Rate-Limit-Remaining":{"$ref":"#/components/headers/x_rate_limit_remaining"},"X-Rate-Limit-Reset":{"$ref":"#/components/headers/x_rate_limit_reset"},"Access-Control-Allow-Origin":{"$ref":"#/components/headers/access_control_allow_origin"}},"content":{"application/vnd.api+json":{"schema":{"$ref":"#/components/schemas/invoice_items/invoice_item_response"}}}},"400":{"$ref":"#/components/responses/bad_request"},"401":{"$ref":"#/components/responses/unauthorized"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/internal_server_error"},"503":{"$ref":"#/components/responses/service_unavailable"}}}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.mews.com/pos-api/operations/invoiceitems.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
